<template>
	<f7-page name="accountedit" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Akun</f7-nav-title>
            <f7-nav-title-large>Detil Profil</f7-nav-title-large>
		</f7-navbar>

		<!-- Page content-->
        <f7-block>
            <div class="display-block text-align-center">
                <div class="img-uploader">
                    <img v-if="user.profile.media != null" :src="user.profile.media.url.large" width="96" class="img-circle">
				    <div v-else :data-initial-extra-large-circle="user.profile.initial"></div>
                </div>
            </div>
        </f7-block> 
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
			<h3 class="no-margin">Penting!</h3>
			<p>Data Anda selalu rahasia dan tidak akan kami beritahukan kepada pihak lain.</p>
		</f7-block>      
        <f7-block-title class="font-bold no-margin-left">Data Diri</f7-block-title>
        <f7-list no-hairlines>
            <f7-list-item title="Nama Lengkap" :after="user.profile.fullname"></f7-list-item>
            <f7-list-item title="Jenis Kelamin" :after="user.profile.gender == 'm' ? 'Laki-Laki' : 'Perempuan'"></f7-list-item>
            <f7-list-item title="Tanggal Lahir" :after="dateFormat(user.profile.birthday, 'DD/MM/YYYY')"></f7-list-item>                
            <f7-list-item v-if="user.role.slug != 'public'" title="Status di Keluarga" :after="relationshipStatus(user.relationship_status)"></f7-list-item>
            <f7-list-item title="No. Handphone" :after="user.profile.phone"></f7-list-item>
            <f7-list-item v-if="user.role.slug != 'public'" :title="`No. ${capitalize(user.profile.idcard)}`" :after="user.profile.idcard_number"></f7-list-item>
        </f7-list>
        <f7-block-title v-if="user.role.slug != 'public'" class="font-bold no-margin">Status Kepemilikan Rumah</f7-block-title>
        <f7-list no-hairlines v-if="user.role.slug != 'public'">
            <f7-list-item title="Status Kepemilikan" :after="residentialStatus(user.profile.residential_status)"></f7-list-item>
            <f7-list-item v-if="user.profile.residential_status != 'owner'" title="Nama Pemilik" :after="user.profile.landlord_name"></f7-list-item>
            <f7-list-item v-if="user.profile.residential_status != 'owner'" title="Alamat Pemilik" :after="user.profile.landlord_address"></f7-list-item>
            <f7-list-item v-if="user.profile.residential_status != 'owner'" title="No. Handphone" :after="user.profile.landlord_phone"></f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, capitalize } from '../js/utils';
export default {
    name: 'AccountView',
    data(){
        return{};
    },
    computed: {
        ...mapGetters('auth', ['user'])
    },
    methods: {
        dateFormat,
        capitalize,
        residentialStatus(status){
            if(status == 'rent'){
                return 'Sewa';
            }else if(status == 'owner'){
                return 'Pemilik';
            }else{
                return 'Rumah Dinas';
            }
        },
        relationshipStatus(status){
            if(status == 'husband'){
                return 'Suami';
            }else if(status == 'wife'){
                return 'Istri';
            }else if(status == 'children'){
                return 'Anak';
            }else if(status == 'parents'){
                return 'Orang Tua';
            }else if(status == 'sibling'){
                return 'Saudara Kandung';
            }else if(status == 'cousin'){
                return 'Sepupu';
            }else if(status == 'newphew'){
                return 'Keponakan';
            }else if(status == 'assistant'){
                return 'Asisten Rumah Tangga';
            }
        },
        onPageBeforeIn(){
            const self = this;
        },
        onPageBeforeOut(page){

        }
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
        const $el = self.$el;

        $$(document).on('click', '.img-uploader', function(e) {
            e.preventDefault();

            var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {

                                    bannerImagePath = bannerImagePath.replace(/\s/g,'%20');
                                    
                                    app.preloader.show('green');

                                    var payload = {
                                        url: '/media/profile/'+self.user.id, 
                                        imagePath: bannerImagePath, 
                                        key: 'media', 
                                        method: 'POST', 
                                        params: {
                                            exclude: 'role.permissions,parents.childs,parents.role.permissions'
                                        }
                                    };

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);

                                            self.$store.dispatch('auth/updateProfile', {
                                                user: response.data.user
                                            });

                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    bannerImagePath = bannerImagePath.replace(/\s/g,'%20');
                                    app.preloader.show('green');

                                    var payload = {
                                        url: '/media/profile/'+self.user.id, 
                                        imagePath: bannerImagePath, 
                                        key: 'media', 
                                        method: 'POST', 
                                        params: {
                                            exclude: 'role.permissions,parents.childs,parents.role.permissions'
                                        }
                                    };
                                    
                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        self.$store.dispatch('auth/updateProfile', {
                                            user: response.data.user
                                        });

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        });
    }
}
</script>
